%define anolis_release 2

Name:           openssl-pkcs11
Version:        0.4.12
Release:        %{anolis_release}%{?dist}
Summary:        A PKCS#11 engine for use with OpenSSL
License:        LGPLv2+ and BSD
URL:            https://github.com/OpenSC/libp11
Source0:        https://github.com/OpenSC/libp11/releases/download/libp11-%{version}/libp11-%{version}.tar.gz

Patch4:         openssl-pkcs11-0.4.10-set-rsa-fips-method-flag.patch
Patch5:         openssl-pkcs11-ossl3.patch

BuildRequires:  make autoconf automake libtool
BuildRequires:  softhsm opensc procps-ng openssl
BuildRequires:  pkgconfig(libcrypto) >= 0.9.8 pkgconfig(openssl) pkgconfig(p11-kit-1)
Requires:       p11-kit-trust

Provides:       libp11 = %{version}-%{release} engine_pkcs11 = %{version}-%{release}
Obsoletes:      libp11 < 0.4.7-4 engine_pkcs11 < 0.4.7-4

%description
The PKCS#11 API is an abstract API to perform operations on cryptographic
objects such as private keys, without requiring access to the objects
themselves. That is, it provides a logical separation of the keys from the
operations. The PKCS #11 API is mainly used to access objects in smart cards
and Hardware or Software Security Modules (HSMs). That is because in these
modules the cryptographic keys are isolated in hardware or software and are not
made available to the applications using them.

PKCS#11 API is an OASIS standard and it is supported by various hardware and
software vendors. Usually, hardware vendors provide a PKCS#11 module to access
their devices. A prominent example is the OpenSC PKCS #11 module which provides
access to a variety of smart cards. Other libraries like NSS or GnuTLS already
take advantage of PKCS #11 to access cryptographic objects.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n libp11-%{version}

%build
%configure --disable-static
%make_build

%install
%make_install

rm -f %{buildroot}%{_libdir}/libp11.so
rm -f %{buildroot}%{_libdir}/pkgconfig/libp11.pc
rm -f %{buildroot}%{_includedir}/*.h
rm -rf %{buildroot}%{_docdir}

%generate_compatibility_deps

%check
%make_build check

%files
%dir %{abidir}
%license COPYING
%{_libdir}/libp11.so.*
%{_libdir}/engines-*/*.so
%{abidir}/*.dump

%files doc
%doc README.md NEWS

%changelog
* Sat Apr 15 2023 Shawn Wang <shawnwang@linux.alibaba.com> - 0.4.12-2
- Add doc package
- Add abi info

* Mon Jan 30 2023 Funda Wang <fundawang@yeah.net> - 0.4.12-1
- New version 0.4.12

* Mon Mar 14 2022 Renbo <rb01097748@alibaba-inc.com> - 0.4.11-1
- Init for Anolis OS 23
